#ifndef SCENE_H_
#define SCENE_H_

#include <vector>
#include "light.h"
#include "camera.h"
#include "bbox.h"
#include "intinfo.h"
#include "object.h"

class Scene {
private: 
	std::vector<Object*> objects;
	Camera *cam;
	Color ambient;
	BBoxNode* bbroot;

public:
	std::vector<Light*> lights;

	Scene();
	~Scene();

	bool load(const char *fname);
	bool load(FILE *fp);

	void add_object(Object* object);
	void set_camera(Camera* cam);
	void set_ambient(const Color &amb);
	Color get_ambient();
	Camera* get_camera();
	bool intersection(const Ray &ray, IntInfo* inter);
	void build_bbtree();
};

#endif
